parser grammar ExtensionAttributeParser;

@header {
import java.io.File;
import java.util.ArrayList;
import org.eclipse.lsp4j.Position;
import org.eclipse.titan.lsp.AST.*;
import org.eclipse.titan.lsp.AST.Identifier.Identifier_type;
import org.eclipse.titan.lsp.AST.IType.MessageEncoding_type;
import org.eclipse.titan.lsp.AST.TTCN3.attributes.*;
import org.eclipse.titan.lsp.AST.TTCN3.attributes.ExtensionAttribute.ExtensionAttribute_type;
import org.eclipse.titan.lsp.AST.TTCN3.definitions.Def_FunctionBase.EncodingPrototype_type;
import org.eclipse.titan.lsp.AST.TTCN3.attributes.PrintingType.PrintingTypeEnum;
import org.eclipse.titan.lsp.AST.TTCN3.types.*;
}

/*
******************************************************************************
 * Copyright (c) 2000-2025 Ericsson Telecom AB
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/org/documents/epl-2.0/EPL-2.0.html
 ******************************************************************************
*/
@members{
  private File actualFile = null;
  private int line = 0;
  private int offset = 0;
  private Position offsetPosition = null;

  public void setActualFile(final File file) {
  	actualFile = file;
  }

  public void setLine(final int line) {
  	this.line = line;
  }

  public void setOffset(final int offset) {
  	this.offset = offset;
  }

 public void setOffsetPosition(final Position offsetPosition) {
	this.offsetPosition = offsetPosition;
}

private Location getLocation(final Token aToken) {
	return getLocation(aToken, aToken);
}

private Location getLocation(final Token aStartToken, final Token aEndToken) {
	final Token endToken = (aEndToken != null) ? aEndToken : aStartToken;
	final int endLen = endToken.getText().length();
	final int lineShift = offsetPosition != null ? offsetPosition.getLine() : 0;
	final int columnShift = (offsetPosition != null && aStartToken.getLine() == 1) ? offsetPosition.getCharacter() : 0;
	final int columnShift2 = (offsetPosition != null && aEndToken.getLine() == 1) ? offsetPosition.getCharacter() : 0;

	return new Location(actualFile,
		aStartToken.getLine() - 1 + lineShift,
		aStartToken.getCharPositionInLine() + columnShift,
		endToken.getLine() - 1 + lineShift,
		endToken.getCharPositionInLine() + endLen + columnShift2);
}
}

/*
 * @author Kristof Szabados
 * */
options {
tokenVocab=ExtensionAttributeLexer;
}

pr_ExtensionAttributeRoot returns[ArrayList<ExtensionAttribute> list]
@init { $list = new ArrayList<ExtensionAttribute>(); }:
(
	a = pr_ExtensionAttribute	{ if($a.attribute != null) {$list.add($a.attribute); } }
)*
EOF
;

pr_ExtensionAttribute returns[ExtensionAttribute attribute]:
(	pr_PrototypeAttribute		{$attribute = $pr_PrototypeAttribute.attribute;}
|	pr_TransparentAttribute		{$attribute = $pr_TransparentAttribute.attribute;}
|	pr_EncodeAttribute		{$attribute = $pr_EncodeAttribute.attribute;}
|	pr_DecodeAttribute		{$attribute = $pr_DecodeAttribute.attribute;}
|	pr_ErrorBehaviorAttribute	{$attribute = $pr_ErrorBehaviorAttribute.attribute;}
|	pr_PrintingAttribute		{$attribute = $pr_PrintingAttribute.attribute;}
|	pr_PortTypeAttribute		{$attribute = $pr_PortTypeAttribute.attribute;}
|	pr_ExtendsAttribute		{$attribute = $pr_ExtendsAttribute.attribute;}
|	pr_AnyTypeAttribute		{$attribute = $pr_AnyTypeAttribute.attribute;}
|	pr_EncDecValueAttribute		{$attribute = $pr_EncDecValueAttribute.attribute;}
|	pr_DoneAttribute		{$attribute = $pr_DoneAttribute.attribute;}
|	pr_VersionAttribute		{$attribute = $pr_VersionAttribute.attribute;}
|	pr_RequiresAttribute		{$attribute = $pr_RequiresAttribute.attribute;}
|	pr_TitanVersionAttribute	{$attribute = $pr_TitanVersionAttribute.attribute;}
);

// Module's own version
pr_VersionAttribute returns[ModuleVersionAttribute attribute]
	locals[Token endCol]
	:
(
	VERSION
	(
		LANGLE
		pr_Identifier	{if($pr_Identifier.identifier != null) {$attribute  = new ModuleVersionAttribute($pr_Identifier.identifier, true);}}
		RANGLE  	{$endCol = $RANGLE;}
	|	pr_Version	{if($pr_Version.identifier != null) {$attribute  = new ModuleVersionAttribute($pr_Version.identifier, false); $endCol =  $pr_Version.stop;}}
	)
)
{
	if ($attribute != null) {
		$attribute.setLocation(getLocation($start, $endCol));
	}
};

// Required version for an imported module
pr_RequiresAttribute returns [VersionRequirementAttribute attribute]
	:
(
	REQUIRES
	pr_Identifier
	pr_Version
)
{
	if ($pr_Identifier.identifier != null && $pr_Version.identifier != null) {
		$attribute = new VersionRequirementAttribute($pr_Identifier.identifier, $pr_Version.identifier);
		$attribute.setLocation(getLocation($start, $pr_Version.stop));
	}
};

// Required Titan version
pr_TitanVersionAttribute returns[TitanVersionAttribute attribute]
	:
(
	REQ_TITAN
	pr_Version
)
{
	if ($pr_Version.identifier != null) {
		$attribute = new TitanVersionAttribute($pr_Version.identifier);
		$attribute.setLocation(getLocation($start, $pr_Version.stop));
	}
};

pr_Version returns [Identifier identifier]
	locals[String temp, Token endCol]
	:
(
	(	x = NUMBER {$temp = $x.getText() + ".";}
		DOT
		y = NUMBER {$temp += $y.getText() + ".";}
		DOT
		z = NUMBER {$temp += $z.getText(); $endCol = $z;}   // 7.2.1
	|	maj = NUMBER {$temp = $maj.getText() + "/";}
		SLASH
		id1 = IDENTIFIER {$temp += $id1.getText();}
		nr1 = NUMBER	{$temp += " " + $nr1.getText();}
		nr2 = NUMBER	{$temp += " " + $nr2.getText();}
		id2 = IDENTIFIER	{$temp += " " + $id2.getText(); $endCol = $id2;}  // 7/CAX 105 7730 R2A
	|	a = IDENTIFIER	{$temp = $a.getText(); $endCol = $a;} 
		(
			b = NUMBER	{$temp += " " + $b.getText();}
			c = NUMBER	{$temp += " " + $c.getText();}
			(
				SLASH
				d = NUMBER	{$temp += "/" + $d.getText();}
			)?
			e = IDENTIFIER	{$temp += " " + $e.getText(); $endCol = $e;} // CNL 113 200 R9A
		)?
	)
)
{
	$identifier = new Identifier(Identifier_type.ID_TTCN, $temp, getLocation($start, $endCol));
};

pr_EncDecValueAttribute returns [ EncDecValueAttribute attribute ]
@init {
	$attribute = new EncDecValueAttribute();
}:
	pr_InOutTypeMappingList [ $attribute ]
;

pr_PrototypeAttribute returns[PrototypeAttribute attribute]
@init { $attribute = null;}:
(
	PROTOTYPE
	LPAREN
	type = pr_PrototypeSetting
	RPAREN
)
{
	if($pr_PrototypeSetting.type != null) {
		$attribute = new PrototypeAttribute($pr_PrototypeSetting.type);
		$attribute.setLocation(getLocation($start, $RPAREN));
	}
};

pr_PrototypeSetting returns[EncodingPrototype_type type]
	:
(
	BACKTRACK	{ $type = EncodingPrototype_type.BACKTRACK; }
|	CONVERT		{ $type = EncodingPrototype_type.CONVERT; }
|	FAST		{ $type = EncodingPrototype_type.FAST; }
|	SLIDING		{ $type = EncodingPrototype_type.SLIDING; }
);

pr_EncodeAttribute returns[EncodeAttribute attribute]:
(
	ENCODE
	LPAREN
	(	pr_EncodingType
		(
			COLON
			pr_EncodingOptions {$attribute = new EncodeAttribute($pr_EncodingType.type, $pr_EncodingOptions.text);}
		|			{$attribute = new EncodeAttribute($pr_EncodingType.type, null);}
		)
	|	pr_CustomEncoding	{$attribute = new EncodeAttribute(MessageEncoding_type.CUSTOM, $pr_CustomEncoding.text);}
	)
	RPAREN
)
{
	$attribute.setLocation(getLocation($start, $RPAREN));
};

pr_DecodeAttribute returns[DecodeAttribute attribute]:
(
	DECODE
	LPAREN
	(	pr_EncodingType
		(
			COLON
			pr_EncodingOptions {$attribute = new DecodeAttribute($pr_EncodingType.type, $pr_EncodingOptions.text);}
		|			{$attribute = new DecodeAttribute($pr_EncodingType.type, null);}
		)
	|	pr_CustomEncoding	{$attribute = new DecodeAttribute(MessageEncoding_type.CUSTOM, $pr_CustomEncoding.text);}
	)
	RPAREN
)
{
	$attribute.setLocation(getLocation($start, $RPAREN));
};

pr_EncodingType returns[MessageEncoding_type type]:
(
	BER	{$type = MessageEncoding_type.BER;}
|	PER	{$type = MessageEncoding_type.PER;}
|	XER	{$type = MessageEncoding_type.XER;}
|	RAW	{$type = MessageEncoding_type.RAW;}
|	TEXT	{$type = MessageEncoding_type.TEXT;}
|	JSON	{$type = MessageEncoding_type.JSON;}
|	OER	{$type = MessageEncoding_type.OER;}
);

pr_CustomEncoding returns[String text]
	:
	IDENTIFIER
{
	$text = $IDENTIFIER.getText();
};

pr_EncodingOptions returns[String text]
	locals[StringBuilder builder, String option]
	:
	{$builder = new StringBuilder();}
(
	pr_EncodingOption	{if($pr_EncodingOption.text != null) { $builder.append($pr_EncodingOption.text); } }
	(
		ANDOP		pr_EncodingOption	{if($pr_EncodingOption.text != null) { $builder.append(" & ").append($pr_EncodingOption.text); } }
	|	OROP		pr_EncodingOption	{if($pr_EncodingOption.text != null) { $builder.append(" | ").append($pr_EncodingOption.text); } }
	)*
)
{
	$text = $builder.toString();
};

pr_EncodingOption returns[String text]
	:
	IDENTIFIER
{
	$text = $IDENTIFIER.getText();
};

pr_ErrorBehaviorAttribute returns[ErrorBehaviorAttribute attribute]
	:
(
	ERRORBEHAVIOR
	LPAREN
	pr_ErrorBehaviorSettingList
	RPAREN
)
{
	if($pr_ErrorBehaviorSettingList.list != null) {
		$attribute = new ErrorBehaviorAttribute($pr_ErrorBehaviorSettingList.list);
		$attribute.setLocation(getLocation($start, $RPAREN));
	}
};

pr_TransparentAttribute returns[TransparentAttribute attribute]
	:
(
	TRANSPARENT
)
{
		$attribute = new TransparentAttribute();
		$attribute.setLocation(getLocation($start, $TRANSPARENT));
};

pr_ErrorBehaviorSettingList returns[ErrorBehaviorList list]
	locals[Token endCol]
	:
	{$list = new ErrorBehaviorList();}
(
	pr_ErrorBehaviorSetting	{$list.addSetting($pr_ErrorBehaviorSetting.behaviorSetting); $endCol = $pr_ErrorBehaviorSetting.stop;}
	(
		COMMA
		pr_ErrorBehaviorSetting		{$list.addSetting($pr_ErrorBehaviorSetting.behaviorSetting); $endCol = $pr_ErrorBehaviorSetting.stop;}
	)*
)
{
	$list.setLocation(getLocation($start, $endCol));
};

pr_ErrorBehaviorSetting returns[ErrorBehaviorSetting behaviorSetting]
	:
(
	errorType = pr_ErrorBehaviorString
	COLON
	errorHandling = pr_ErrorBehaviorString
)
{
	$behaviorSetting = new ErrorBehaviorSetting($errorType.string, $errorHandling.string);
	$behaviorSetting.setLocation(getLocation($start, $pr_ErrorBehaviorString.stop));
};

pr_ErrorBehaviorString returns[String string]
	:
(
	IDENTIFIER
)
{
	$string = $IDENTIFIER.getText();
};

pr_PrintingAttribute returns[PrintingAttribute attribute]
	:
(
	PRINTING
	LPAREN
	pr_PrintingType
	RPAREN
)
{
	if($pr_PrintingType.printingType != null) {
		$attribute = new PrintingAttribute($pr_PrintingType.printingType);
		$attribute.setLocation(getLocation($start, $RPAREN));
	}
};

pr_PrintingType returns[PrintingType printingType]
	locals[PrintingTypeEnum pte, Token endCol]
	:
	{$pte = PrintingTypeEnum.NONE;}
(
	COMPACT	{$pte = PrintingTypeEnum.COMPACT; $endCol = $COMPACT;}
|	PRETTY	{$pte = PrintingTypeEnum.PRETTY; $endCol = $PRETTY;}
)
{
	if($pte != PrintingTypeEnum.NONE) {
		$printingType = new PrintingType($pte);
		$printingType.setLocation(getLocation($start, $endCol));
	}
};

pr_PortTypeAttribute returns[PortTypeAttribute attribute]
	locals[Token endCol]
	:
(
	INTERNAL	{$attribute = new InternalPortTypeAttribute(); $endCol = $INTERNAL;}
|	ADDRESS		{$attribute = new AddressPortTypeAttribute(); $endCol = $ADDRESS;}
|	PROVIDER	{$attribute = new ProviderPortTypeAttribute(); $endCol = $PROVIDER;}
|	pr_UserAttribute	{$attribute = $pr_UserAttribute.attribute; $endCol = $pr_UserAttribute.stop;}
)
{
	if ($attribute != null) {
		$attribute.setLocation(getLocation($start, $endCol));
	}
};

pr_UserAttribute returns[UserPortTypeAttribute attribute]
	:
(
	USER
	pr_PortTypeReference	{if($pr_PortTypeReference.reference != null) {$attribute = new UserPortTypeAttribute($pr_PortTypeReference.reference);}}
	pr_InOutTypeMappingList[$attribute]
);

pr_PortTypeReference returns[Reference reference]
	:
	pr_Reference	{$reference = $pr_Reference.reference;}
;

pr_InOutTypeMappingList[ IInOutTypeMappingAttribute attribute ]:
(
	pr_InOutTypeMapping[$attribute]
)+
;

pr_InOutTypeMapping[ IInOutTypeMappingAttribute attribute ]:
(
	IN
	LPAREN
	pr_TypeMappingList	{if($attribute != null) {$attribute.setInMappings($pr_TypeMappingList.mappings);}}
	RPAREN
|	OUT
	LPAREN
	pr_TypeMappingList	{if($attribute != null) {$attribute.setOutMappings($pr_TypeMappingList.mappings);}}
	RPAREN
)
{
	if($attribute != null) {
		$attribute.setLocation(getLocation($start, $RPAREN));
	}
};

pr_TypeMappingList returns [TypeMappings mappings]
	:
	{$mappings = new TypeMappings();}
(
	pr_TypeMapping	{ if($pr_TypeMapping.typeMapping != null) {$mappings.add($pr_TypeMapping.typeMapping); } }
	(
		SEMICOLON
		pr_TypeMapping	{ if($pr_TypeMapping.typeMapping != null) {$mappings.add($pr_TypeMapping.typeMapping); } }
	)*
)
{
	$mappings.setLocation(getLocation($start, $pr_TypeMapping.stop));
};

pr_TypeMapping returns[TypeMapping typeMapping]
	:
(
	pr_Type
	REDIRECTSYMBOL
	pr_TypeMappingTargetList
)
{
	$typeMapping = new TypeMapping($pr_Type.type, $pr_TypeMappingTargetList.targets);
	$typeMapping.setLocation(getLocation($start, $pr_TypeMappingTargetList.stop));
};

pr_TypeMappingTargetList returns[TypeMappingTargets targets]
	:
	{$targets = new TypeMappingTargets();}
(
	pr_TypeMappingTarget	{if($pr_TypeMappingTarget.mappingTarget != null) { $targets.add($pr_TypeMappingTarget.mappingTarget); } }
	(
		COMMA
		pr_TypeMappingTarget	{if($pr_TypeMappingTarget.mappingTarget != null) { $targets.add($pr_TypeMappingTarget.mappingTarget); } }
	)*
);

pr_TypeMappingTarget returns[TypeMappingTarget mappingTarget]
	locals[EncodeMappingHelper helper, Token endCol]
	:
(
	DASH
	COLON
	DISCARD		{$mappingTarget = new DiscardTypeMappingTarget(); $endCol = $DISCARD;}
|	pr_Type
	COLON
	(
		SIMPLE				{$mappingTarget = new SimpleTypeMappingTarget($pr_Type.type);}
	|	pr_FunctionMapping	{$mappingTarget = new FunctionTypeMappingTarget($pr_Type.type, $pr_FunctionMapping.reference);}
	|	pr_EncodeMapping	{if($pr_EncodeMapping.helper != null)
							{$mappingTarget = new EncodeTypeMappingTarget($pr_Type.type, $pr_EncodeMapping.helper.encodeAttribute, $pr_EncodeMapping.helper.errorBehaviorAttribute);}
							}
	|	pr_DecodeMapping	{if($pr_DecodeMapping.helper != null)
							{$mappingTarget = new DecodeTypeMappingTarget($pr_Type.type, $pr_DecodeMapping.helper.encodeAttribute, $pr_DecodeMapping.helper.errorBehaviorAttribute);}
							}
	)
	{$endCol = $pr_Type.stop;}
)
{
	if ($mappingTarget != null) {
		$mappingTarget.setLocation(getLocation($start, $endCol));
	}
};

pr_FunctionMapping returns[Reference reference]
	:
(
	FUNCTION
	LPAREN
	pr_FunctionReference	{$reference = $pr_FunctionReference.reference;}
	RPAREN
);

pr_FunctionReference returns[Reference reference]:
	pr_Reference	{$reference = $pr_Reference.reference;}
;

pr_EncodeMapping returns[EncodeMappingHelper helper]
	locals[boolean hasErrorBehaviorAttribute]:
(
	encodeAttribute = pr_EncodeAttribute {$hasErrorBehaviorAttribute = false;}
	(
		errorBehaviorAttribute = pr_ErrorBehaviorAttribute
	)?
	(
		printingAttribute = pr_PrintingAttribute {$hasErrorBehaviorAttribute = true;}
	)?
)
{
	if ($hasErrorBehaviorAttribute) {
		$helper = new EncodeMappingHelper($encodeAttribute.attribute, $errorBehaviorAttribute.attribute);
	}
	else {
		$helper = new EncodeMappingHelper($encodeAttribute.attribute, null);
	}
};

pr_DecodeMapping returns[EncodeMappingHelper helper]
	locals[boolean hasErrorBehaviorAttribute]:
(
	decodeAttribute = pr_DecodeAttribute {$hasErrorBehaviorAttribute = false;}
	(
		errorBehaviorAttribute = pr_ErrorBehaviorAttribute {$hasErrorBehaviorAttribute = true;}
	)?
)
{
	if ($hasErrorBehaviorAttribute) {
		$helper = new EncodeMappingHelper($decodeAttribute.attribute, $errorBehaviorAttribute.attribute);
	}
	else {
		$helper = new EncodeMappingHelper($decodeAttribute.attribute, null);
	}
};

pr_ExtendsAttribute returns[ExtensionsAttribute attribute]
	:
(
	EXTENDS
	types = pr_ExtensionList
)
{
	if($types.types != null) {
		$attribute = new ExtensionsAttribute($types.types);
		$attribute.setLocation(getLocation($start, $types.stop));
	}
};

pr_ExtensionList returns[Types types]
	:
	{$types = new Types();}
(
	pr_ReferencedType	{ if ($pr_ReferencedType.type != null) { $types.add($pr_ReferencedType.type); } }
	(
		COMMA
		pr_ReferencedType	{ if ($pr_ReferencedType.type != null) { $types.add($pr_ReferencedType.type); } }
	)*
);

pr_AnyTypeAttribute returns[AnytypeAttribute attribute]
	:
(
	ANYTYPE
	pr_TypeList
)
{
	if($pr_TypeList.types != null) {
		$attribute = new AnytypeAttribute($pr_TypeList.types);
		$attribute.setLocation(getLocation($start, $pr_TypeList.stop));
	}
};

pr_TypeList returns[Types types]
	:
	{$types = new Types();}
(
	pr_Type	{ if ($pr_Type.type != null) { $types.add($pr_Type.type); } }
	(
		COMMA
		pr_Type	{ if ($pr_Type.type != null) { $types.add($pr_Type.type); } }
	)*
);

pr_Type returns[Type type]:
(
	pr_PredefinedType	{$type = $pr_PredefinedType.type;}
|	pr_ReferencedType	{$type = $pr_ReferencedType.type;}
);

pr_PredefinedType returns[Type type]
	locals[Token endCol]
	:
(
	BITSTRING	{ $type = new BitString_Type(); $endCol = $BITSTRING; }
|	BOOLEAN		{ $type = new Boolean_Type(); $endCol = $BOOLEAN; }
|	CHARSTRING	{ $type = new CharString_Type(); $endCol = $CHARSTRING; }
|	UNIVERSAL
	CHARSTRING	{ $type = new UniversalCharstring_Type(); $endCol = $CHARSTRING; }
|	INTEGER		{ $type = new Integer_Type(); $endCol = $INTEGER; }
|	OCTETSTRING	{ $type = new OctetString_Type(); $endCol = $OCTETSTRING; }
|	HEXSTRING	{ $type = new HexString_Type(); $endCol = $HEXSTRING; }
|	VERDICTTYPE	{ $type = new Verdict_Type(); $endCol = $VERDICTTYPE; }
|	FLOAT		{ $type = new Float_Type(); $endCol = $FLOAT; }
|	ADDRESS		{ $type = new Address_Type(); $endCol = $ADDRESS; }
|	DEFAULT		{ $type = new Default_Type(); $endCol = $DEFAULT; }
|	ANYTYPE		{ $type = new Boolean_Type(); $type.setIsErroneous(true); $endCol = $ANYTYPE; }
|	OBJECTIDENTIFIER	{ $type = new ObjectID_Type(); $endCol = $OBJECTIDENTIFIER; }
)
{
	$type.setLocation(getLocation($start, $endCol));
};

pr_ReferencedType returns [Type type]
	:
(
	reference = pr_Reference
)
{
	if ($pr_Reference.reference != null) {
		$type = new Referenced_Type($pr_Reference.reference);
		$type.setLocation(getLocation($start, $reference.stop));
	}
};

pr_Reference returns[Reference reference]
	locals[Identifier identifier1, Identifier identifier2]
	:
(
	pr_Identifier	{$identifier1 = $pr_Identifier.identifier;}
	(
		DOT
		pr_Identifier {$identifier2 = $pr_Identifier.identifier;}
	)?
)
{
	if ($identifier1 != null) {
		if ($identifier2 == null) {
			$reference = new Reference(null);
			FieldSubReference subReference = new FieldSubReference($identifier1);
			subReference.setLocation(getLocation($start, $pr_Identifier.stop));
			$reference.addSubReference(subReference);
		} else {
			$reference = new Reference($identifier1);
			FieldSubReference subReference = new FieldSubReference($identifier2);
			subReference.setLocation(getLocation($start, $pr_Identifier.stop));
			$reference.addSubReference(subReference);
		}
	}
};

pr_Identifier returns [Identifier identifier]
	:
(
	IDENTIFIER
)
{
	if($IDENTIFIER.getTokenIndex() >= 0) {
		final String text = $IDENTIFIER.text;
		if(text != null) {
			$identifier = new Identifier(Identifier_type.ID_TTCN, text, getLocation($IDENTIFIER));
		}
	}
};

pr_DoneAttribute returns[DoneAttribute attribute]
	:
(
	DONE
)
{
	$attribute=new DoneAttribute();
	$attribute.setLocation(getLocation($start, $DONE));
};
